/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Send Page by Email (spbeOptions.js).
 *
 * The Initial Developer of the Original Code is Weidong Lu.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Weidong Lu <lwd.firefox@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function spbe_initOptions(){

	sizeToContent();
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");

    document.getElementById("spbe_sourceEmail").value = spbeOptions.getCharPref("opt_sourceEmail");
    document.getElementById("spbe_smtpServer").value = spbeOptions.getCharPref("opt_smtpServer");
    document.getElementById("spbe_portNumber").value = spbeOptions.getIntPref("opt_portNumber");
    document.getElementById("spbe_smtpUser").value = spbeOptions.getCharPref("opt_smtpUser");
    document.getElementById("spbe_smtpPass").value = spbeOptions.getCharPref("opt_smtpPass");
    document.getElementById("spbe_pathToEmailProgram").value = spbeOptions.getCharPref("opt_pathToEmailProgram");
    document.getElementById("spbe_pathToTempFile").value = spbeOptions.getCharPref("opt_pathToTempFile");
	spbe_listBoxInit(document.getElementById("spbe_emailListBox"), spbeOptions.getCharPref("opt_emailList"));
	spbe_listBoxInit(document.getElementById("spbe_labelListBox"), spbeOptions.getCharPref("opt_labelList"));
	var charsetIndex = spbeOptions.getIntPref("opt_charsetIndex");
	if (charsetIndex == -1) document.getElementById("spbe_charset").value = spbeOptions.getCharPref("opt_charset");
		else  document.getElementById("spbe_charset").selectedIndex = charsetIndex;
}

function spbe_saveOptions(){

	var flag = 1;
	var pathToEmailProgram = document.getElementById("spbe_pathToEmailProgram").value;
	var pathToTempFile = document.getElementById("spbe_pathToTempFile").value;
    var sourceEmail = document.getElementById("spbe_sourceEmail").value;
	var smtpServer = document.getElementById("spbe_smtpServer").value;
	var portNumber = document.getElementById("spbe_portNumber").value;

	if ((sourceEmail.indexOf("@") == -1) || (smtpServer == "") || (portNumber == 0)){
		alert("Please specify the correct value of sender's email address/SMTP Server/Port Number.");
		flag = 0;
	}
	else if (pathToEmailProgram.indexOf("sendEmail.exe") == -1) {
		alert("Please specify the correct path to sendEmail.exe program.");
		flag = 0;
	} 
	else if (pathToTempFile == "") {
	    alert("Please specify the path to temporary files.");
		flag = 0;
	} 

	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");	
	spbeOptions.setCharPref("opt_sourceEmail", sourceEmail);
	spbeOptions.setCharPref("opt_smtpServer", smtpServer);
	spbeOptions.setIntPref("opt_portNumber", portNumber);
	spbeOptions.setCharPref("opt_smtpUser", document.getElementById("spbe_smtpUser").value);
	spbeOptions.setCharPref("opt_smtpPass", document.getElementById("spbe_smtpPass").value);
	spbeOptions.setCharPref("opt_pathToEmailProgram", pathToEmailProgram);
	spbeOptions.setCharPref("opt_pathToTempFile", pathToTempFile);
	spbeOptions.setCharPref("opt_emailList", spbe_listBoxToString(document.getElementById("spbe_emailListBox")));
	spbeOptions.setCharPref("opt_labelList", spbe_listBoxToString(document.getElementById("spbe_labelListBox")));
	spbeOptions.setCharPref("opt_charset", document.getElementById("spbe_charset").value);
	spbeOptions.setIntPref("opt_charsetIndex", document.getElementById("spbe_charset").selectedIndex);
	
    if (flag == 0) window.openDialog('chrome://sendpagebyemail/content/spbeOptions.xul');
}

function spbe_listBoxInit( listBox, listString ){
	if (listString != "") {
		var stringArray = listString.split("|");
   
		for (var n = 0; n < stringArray.length; n++)
			listBox.appendItem(stringArray[n], stringArray[n]);
	}
}

/* function excuted when add or delete buttons are clicked*/
function spbe_addItem( listBox, spbe_element){
	
	var spbe_item = spbe_element.value;
	if (!spbe_listBoxHasItem(spbe_item, listBox)) {
		listBox.appendItem(spbe_item, spbe_item);
		spbe_element.value = "";
	}
	else 
		alert("This value already exists in the list.");
}


function spbe_listBoxHasItem(listItemValue, listBox){
	
	var hasItem = false;
	var rowCount = listBox.getRowCount();
	if (rowCount > 0){
		for (var i = 0; i < rowCount; i++){
			if (listItemValue == listBox.getItemAtIndex(i).value) {
				hasItem = true;
				break;
			}
		}
	}
	return hasItem;
}


function spbe_delItem( listBox){

	var selectedindex = listBox.selectedIndex;
    listBox.removeItemAt(selectedindex);        
}

function spbe_itemUp( listBox){
	var selectedIndex = listBox.selectedIndex;
	var selectedText = listBox.selectedItem.value;
	listBox.insertItemAt(selectedIndex-1, selectedText, selectedText);
	listBox.removeItemAt(selectedIndex+1);
}

function spbe_itemDown( listBox){
	var selectedIndex = listBox.selectedIndex;
	var selectedText = listBox.selectedItem.value;
	listBox.insertItemAt(selectedIndex+2, selectedText, selectedText);
	listBox.removeItemAt(selectedIndex);
}

function spbe_browseFile(nodeID, flag){

      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
      if (flag == "open")
		  fp.init(window, null, nsIFilePicker.modeOpen);
	  else 
		  fp.init(window, null, nsIFilePicker.modeGetFolder);

      fp.appendFilters(nsIFilePicker.filterAll);
      var result = fp.show();
      if (result == nsIFilePicker.returnOK) {
		  if (flag == "open")
			  document.getElementById(nodeID).value = fp.file.target;
		  else 
			  document.getElementById(nodeID).value = fp.file.target + "\\";
	  }
}

function spbe_listBoxToString(listBox){
 
	var listBoxString = "";
	var rowCount = listBox.getRowCount();
	if (rowCount > 0) {
		for (var i = 0; i < (rowCount-1); i++) {
			listBoxString = listBoxString + listBox.getItemAtIndex(i).value + "|";
		}
		listBoxString = listBoxString + listBox.getItemAtIndex(i).value;
	} 
	return listBoxString;
}

