/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Send Page by Email (spbeOverlay.js).
 *
 * The Initial Developer of the Original Code is Weidong Lu.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * Weidong Lu <lwd.firefox@gmail.com>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */


function spbe_showDialog(){
	window.openDialog("chrome://sendpagebyemail/content/spbeDialog.xul","showmore", "chrome", window);
}

function spbe_dialogInit(spbe_win){
	
	window.sizeToContent();
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");
	
	if ((!spbeOptions.prefHasUserValue("opt_sourceEmail")) || (!spbeOptions.prefHasUserValue("opt_smtpServer")) || (!spbeOptions.prefHasUserValue("opt_portNumber"))) {
		alert("Please complete the required fields in Options dialog.");
		window.openDialog('chrome://sendpagebyemail/content/spbeOptions.xul', 'showoptions', 'chrome');
	}

	//initialize three email address fields (TO: CC: and BCC:)
	spbe_addressListInit(document.getElementById("spbe_toMenuItem"), spbeOptions.getCharPref("opt_emailList"), "1");
    spbe_addressListInit(document.getElementById("spbe_ccMenuItem"), spbeOptions.getCharPref("opt_emailList"), "2");
    spbe_addressListInit(document.getElementById("spbe_bccMenuItem"), spbeOptions.getCharPref("opt_emailList"), "3");
	
	//initialize the Subject Field & Content Field
	var subjectField = document.getElementById("spbe_subject");
	var contentField =  document.getElementById("spbe_contentRadioGroup");
    var webpageTitle = spbe_win.document.title;
    webpageTitle = webpageTitle.replace(" - Mozilla Firefox", "");
	subjectField.appendItem(webpageTitle, webpageTitle);
	subjectField.selectedIndex = 0;
	contentField.selectedIndex = 0;// Webpage is selected as default content	

	var selectedtxt = spbe_win.document.commandDispatcher.focusedWindow.getSelection().toString();;     
	if (selectedtxt != "") {
		subjectField.appendItem(selectedtxt, selectedtxt);
	    contentField.selectedIndex = 1;        
		if (selectedtxt.length < 20){ // if length<20 use selected text as Subject and choose webpage as content 
			subjectField.selectedIndex = 1;
			contentField.selectedIndex = 0;
		}//Otherwise, use the title of the website as Subject and choose selected text content
	}
    
    //initialize the Encoding Field
	var charsetField = document.getElementById("spbe_emailCharset");
    var userCharset = spbeOptions.getCharPref("opt_charset"); 
	var charsetIndex = spbeOptions.getIntPref("opt_charsetIndex"); 
    charsetField.appendItem("Chinese Simplified (GB2312)", "GB2312");
    charsetField.appendItem("Chinese Traditional (Big5)", "Big5");
    charsetField.appendItem("Unicode (UTF-8)", "UTF-8");
    charsetField.appendItem("Western European (ISO-8859-1)", "ISO-8859-1");

	if (charsetIndex == -1) { 
		charsetField.appendItem(userCharset, userCharset);
		charsetField.selectedIndex = 4;
	}
	else charsetField.selectedIndex = charsetIndex;

	//initalize the label field
	spbe_labelListInit(document.getElementById("spbe_labelMenuItem"), spbeOptions.getCharPref("opt_labelList"));

	//initalize the attachment field
	document.getElementById("spbe_attachment").appendItem("","");
	document.getElementById("spbe_attachment").selectedIndex = 0;

	//set focus on subject field
	subjectField.select();
	subjectField.focus();

}

function spbe_addressListInit( menuList, menuListString, flag ){

	var stringArray = menuListString.split("|");
	var horizontalItem = new Array();
	var horizontalNode = new Array();
    var checkItem = new Array();
	var addressField;
	
	if (flag == "1") {
		addressField = document.getElementById("spbe_toList");
		addressField.label = stringArray[0] + ";";// if flag is true, set the first item as default
	} 

	for (var n = 0; n < stringArray.length; n++){
		horizontalItem[n] = document.createElement("hbox");
		horizontalNode[n] = menuList.appendChild(horizontalItem[n]);
		checkItem[n] = document.createElement("checkbox");
		if (stringArray[n].length > 60) checkItem[n].setAttribute("label", stringArray[n].substring(0,57)+"...");
		else checkItem[n].setAttribute("label", stringArray[n]);
		checkItem[n].setAttribute("value", stringArray[n]);
		checkItem[n].setAttribute("maxwidth", "50");
		checkItem[n].setAttribute("width", "50");
		checkItem[n].setAttribute("crop", "start");
		checkItem[n].setAttribute("id", flag+"-"+stringArray[n]);
		checkItem[n].setAttribute("oncommand", "spbe_addToAddressField('"+flag+"', '"+stringArray[n]+"');");
		horizontalNode[n].appendChild(checkItem[n]);
	}
}

function spbe_addToAddressField( flag, checkedTxt ){

	var chkbox = document.getElementById(flag+"-"+checkedTxt);
	var menuItem;
    if (flag == "1") menuItem = document.getElementById("spbe_toList");
    else if (flag == "2") menuItem = document.getElementById("spbe_ccList");
    else if (flag == "3") menuItem = document.getElementById("spbe_bccList");

	var originalValue = menuItem.value;
    // if checked, add the checkedTxt, if unchecked, remove the checkedTxt from subject
	if (chkbox.checked == 1)  { 
		menuItem.label = originalValue + checkedTxt + ";";
		menuItem.value = originalValue + checkedTxt + ";";
	}
	else if (chkbox.checked == 0) { 
		 menuItem.label = originalValue.replace(checkedTxt + ";", "");
		 menuItem.value = originalValue.replace(checkedTxt + ";", "");
	}
}

function spbe_labelListInit( menuList, menuListString){

	var stringArray = menuListString.split("|");
    var checkItem = new Array();
    var horizontalItem = new Array();
	var horizontalNode = new Array();
	
	for (var n = 0; n < stringArray.length; n++){
		if (( n % 3 ) == 0){ //add a hbox in order to put three labels in a row 
			var i = n/3;
			horizontalItem[i] = document.createElement("hbox"); 
			horizontalNode[i] = menuList.appendChild(horizontalItem[i]);
		}
		checkItem[n] = document.createElement("checkbox");
		if (stringArray[n].length > 15) checkItem[n].setAttribute("label", stringArray[n].substring(0,14));
		else checkItem[n].setAttribute("label", stringArray[n]);
		checkItem[n].setAttribute("tooltiptext", stringArray[n]);
		checkItem[n].setAttribute("width", "120");
		checkItem[n].setAttribute("maxwidth", "120");
		checkItem[n].setAttribute("id", stringArray[n]);
		checkItem[n].setAttribute("oncommand", "spbe_labelSubject('"+stringArray[n]+"');");
		horizontalNode[i].appendChild(checkItem[n]);
	}
	menuList.parentNode.selectedIndex = 0;
}

function spbe_labelSubject( checkedTxt ){

	var subject = document.getElementById("spbe_subject").value;
	var chkbox = document.getElementById(checkedTxt);
    // if checked, add the checkedTxt, if unchecked, remove the checkedTxt from subject
	if (chkbox.checked == 1) document.getElementById("spbe_subject").value = subject + " - " + checkedTxt;
	else if (chkbox.checked == 0) { 
		 document.getElementById("spbe_subject").value = subject.replace(" - "+ checkedTxt, "");;
	}
}

function spbe_handleAttachment(nodeID, flag){
	// handle attachment according to flag ("add","del","clear")
      var nsIFilePicker = Components.interfaces.nsIFilePicker;
      var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	  var attachmentMenu = document.getElementById(nodeID);
	  var selindex = attachmentMenu.selectedIndex;
      if (flag == "add") {
		  fp.init(window, null, nsIFilePicker.modeOpen);
		  fp.appendFilters(nsIFilePicker.filterAll);
		  var result = fp.show();
		  if (result == nsIFilePicker.returnOK) {
			  attachmentMenu.appendItem(fp.file.leafName+" ("+fp.file.path+")", fp.file.target);
			  attachmentMenu.selectedIndex = selindex +1;
		  }
	  }
	  else if (flag == "del") {
		  attachmentMenu.removeItemAt(selindex);
		  if (selindex > 0) attachmentMenu.selectedIndex = selindex - 1;//show the item before deleted one 
		  else { // the deleted item is the first item and thus show only a blank item
			  attachmentMenu.appendItem("",""); 
			  attachmentMenu.selectedIndex = 0;
		  } 
	  }
	  else { // clear all files
		  attachmentMenu.removeAllItems(); 
		  attachmentMenu.appendItem("",""); 
		  attachmentMenu.selectedIndex = 0;
	  }
}

function convertUnicode(charset, str) {
    try {
			var convUnicode = Components.classes['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
			convUnicode.charset = charset;
			str = convUnicode.ConvertFromUnicode(str);
			return str + convUnicode.Finish();
    } catch (e) {
        return null;
    }
}

function convertAllRelativeLinks(currentDoc, currenthref){

	var srcURL;

	// convert image links
	var allImages = currentDoc.getElementsByTagName("img");

	for (var i=0;i<allImages.length;i++){
		srcURL = allImages[i].getAttribute("src");
		if (srcURL != ""){
			srcURL = relativeToAbsoluteLink(currenthref, srcURL);
			allImages[i].setAttribute("src", srcURL);
		}	 
	}
	
	// convert CSS links
	var allCssLinks = currentDoc.getElementsByTagName("link");
	for (var i=0;i<allCssLinks.length;i++){
		hrefURL = allCssLinks[i].getAttribute("href");
		if (hrefURL != ""){
			hrefURL = relativeToAbsoluteLink(currenthref, hrefURL);
			allCssLinks[i].setAttribute("href", hrefURL);
		}
	}

	// convert URL links
	var allUrlLinks = currentDoc.getElementsByTagName("a");
	for (var i=0;i<allUrlLinks.length;i++){
		hrefURL = allUrlLinks[i].getAttribute("href");
		if (hrefURL != ""){
			hrefURL = relativeToAbsoluteLink(currenthref, hrefURL);
			allUrlLinks[i].setAttribute("href", hrefURL);
		}
	}
}


function relativeToAbsoluteLink(baseURL, relativeURL){

	var absoluteURL;
	var parsedURL = parseBaseURL(baseURL);

	if ((relativeURL == null) || (relativeURL.indexOf("://") != -1) || (relativeURL.indexOf("mailto:") != -1) || (relativeURL.indexOf("javascript:") != -1)){
		return relativeURL;
	}

	if (relativeURL.charAt(0) == "/") { // <img src="/images/image.gif">
		absoluteURL = parsedURL[0] + parsedURL[1] + relativeURL;
		return absoluteURL;
	} 
	else if ((relativeURL.charAt(0) == ".") && (relativeURL.charAt(1) == "/")) {//<img src="./images/image.gif">
		
		absoluteURL = parsedURL[0] + parsedURL[1] + parsedURL[2] + relativeURL.substring(2, relativeURL.length);
		return absoluteURL;
	}
	else if (relativeURL.indexOf("../") != -1) {// <img src="../../images/image.gif">
		var relativeURLArray = relativeURL.split("../");		
		var pathArray = parsedURL[2].split("/");
		absoluteURL = parsedURL[0] + parsedURL[1];
		for (var i = 0; i < pathArray.length - relativeURLArray.length; i++)
			absoluteURL = absoluteURL + pathArray[i] + "/";
		absoluteURL = absoluteURL + relativeURLArray[relativeURLArray(relativeURLArray.length-1)];
		return absoluteURL;
	}
	else {// <img src="images/image.gif">
		absoluteURL = parsedURL[0] + parsedURL[1];
		
		if (parsedURL[2] != null) absoluteURL = absoluteURL + parsedURL[2] + "/"+relativeURL;
		else absoluteURL = absoluteURL + "/" + relativeURL;
		
		return absoluteURL;
	}
}


function parseBaseURL(url){
	
	var parsedURL = new Array(); //0:protocol;1:host;2:path
	var pos = url.indexOf("://");
	var lastpos;
	var temp_url;

	if ( pos != -1) {
		parsedURL[0] = url.substring(0, pos+3);
		temp_url = url.substring(pos+3, url.length);
	    pos = temp_url.indexOf("/");
		lastpos = temp_url.lastIndexOf("/");
		if (pos!= -1) {
			parsedURL[1] = temp_url.substring(0, pos);
			if (pos != lastpos) parsedURL[2] = temp_url.substring(pos, lastpos);
		}	
		else parsedURL[1] = temp_url;
				
	}
    else {
		pos = url.indexOf("/");
        lastpos = url.lastIndexOf("/");
		if ((pos != -1) && (pos < lastpos)) {
				parsedURL[1] = url.substring(0, pos);
				parsedURL[2] = url.substring(pos, lastpos);
			}
		else {
			parsedURL[1] = url;
		}
	}
	return parsedURL;
}


function spbe_sendemail( spbe_win, flag){

	var tmpflag = 0;
	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");		  
	var emailApp = Components.classes["@mozilla.org/file/local;1"].getService(Components.interfaces.nsILocalFile);
	emailApp.initWithPath(spbeOptions.getCharPref("opt_pathToEmailProgram"));
	var tempfilepath = spbeOptions.getCharPref("opt_pathToTempFile");
	if (tempfilepath == "") { 
		alert("Please specify the path to temporary files in the Options Dialog."); 
		tmpflag = 1; //temp path not ready 
	}

    // obtain the html code and perform encoding convertion
	var docCharset = spbe_win._content.document.characterSet;//get the charset of the website
	var userCharset = document.getElementById("spbe_emailCharset").value; // user defined Encoding for outgoing email

	if ((docCharset != userCharset) && (userCharset != "")) {
		if (confirm("Your preferred encoding ("+userCharset+") is not compatible with the encoding of the webpage ("+ docCharset +").\n  Press 'OK' for "+userCharset+".\n Press 'Cancel' for "+docCharset+". \n\n Please be aware that email recipients may need to change the encoding of the email in order to read properly."))
		{
				docCharset = userCharset; // if confirm() returns OK, use user defined encoding method, otherwise use the encoding of the webpage.
		}
	}

	var focusedWindow = spbe_win.document.commandDispatcher.focusedWindow;
	//if (focusedWindow == window)  focusedWindow = spbe_win._content;
	var emailTitle = document.getElementById("spbe_subject").value; 
	var	emailSubject = convertUnicode(docCharset, emailTitle); 
	var userContent = convertUnicode(docCharset, document.getElementById("spbe_userContent").value);
	var weblink = "<a href='"+focusedWindow.location.href+"' target='_blank'>"+focusedWindow.location.href+"</a>";
	var radioGroupIndex = document.getElementById("spbe_contentRadioGroup").selectedIndex;

    var tmpfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile); 
    tmpfile.initWithPath(tempfilepath+"spbe_tmp.html");
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"] .createInstance(Components.interfaces.nsIFileOutputStream);
    foStream.init(tmpfile, 0x04 | 0x08 | 0x20, 0664, 0);
    

	var textToBeSent = "";
	userContent = stringRecursiveReplace(userContent, '\n', "<br>"); //convert RET to html code

	if ( radioGroupIndex == 0 ) { // Send webpage selected
		convertAllRelativeLinks(focusedWindow.document, focusedWindow.location.href);
		var htmlNode = focusedWindow.document.getElementsByTagName("html");		
		var websrcenc = convertUnicode(docCharset, htmlNode[0].innerHTML);
        
		textToBeSent = "<html>"+ userContent + "<BR><BR>" + weblink + "<BR><BR>" + websrcenc + "</html>";
		foStream.write(textToBeSent, textToBeSent.length);
	}			
	else if (radioGroupIndex == 1) { // Send selected text selected

		textToBeSent = convertUnicode(docCharset, focusedWindow.getSelection().toString());
		textToBeSent = stringRecursiveReplace(textToBeSent, '\n', "<br>");
		textToBeSent ="<html>"+ userContent + "<BR><BR>" + focusedWindow.location.href + "<BR><BR>" + textToBeSent + "</html>"; // add the link to the webpage where the text is selected.	
		foStream.write(textToBeSent, textToBeSent.length);
	}
	else {  // Send user content only selected

		textToBeSent = "<html>"+userContent+"</html>";
		foStream.write(textToBeSent, textToBeSent.length);
	}
	
	foStream.close();

	if ((flag == "true") && (tmpflag == 0)) {
		// send email
		var emailArgs = ['-f', spbeOptions.getCharPref("opt_sourceEmail"), '-t', document.getElementById("spbe_toList").value, '-cc', document.getElementById("spbe_ccList").value, '-bcc', document.getElementById("spbe_bccList").value, '-s', spbeOptions.getCharPref("opt_smtpServer")+":"+spbeOptions.getIntPref("opt_portNumber"),'-u', emailSubject, '-o', "message-charset="+docCharset, '-o', "message-file="+tmpfile.path, '-l', tempfilepath+"spbe_log.txt", '-q'];
		// put all the arguments to be passed to the external program in an array.
		/* **********************add more arguments according to user selections in the dialog********************/

		var smtpUser = spbeOptions.getCharPref("opt_smtpUser");
		var smtpPass = spbeOptions.getCharPref("opt_smtpPass");
		if ( smtpUser != "") {
			emailArgs.push('-xu', smtpUser);
		}
		if ( smtpPass != "") {
			emailArgs.push('-xp', smtpPass);
		}		
        var attachedItems = document.getElementById("spbe_attachment").firstChild.childNodes;
		if (attachedItems.length > 1){
			emailArgs.push('-a');
			for (var i = 0; i < attachedItems.length; i++){
				if (attachedItems[i].value != "") emailArgs.push(attachedItems[i].value);
		    }
		}
		/* **********************end of add more arguments according to user selections in the dialog*************************** */

		if (emailApp.exists()) {
			var emailProcess = Components.classes["@mozilla.org/process/util;1"].getService(Components.interfaces.nsIProcess);
			emailProcess.init(emailApp);
  			emailProcess.run(false, emailArgs, emailArgs.length);
			spbe_win.setTimeout("validateSentEmail('" + emailSubject + "'," + 1 +");", 3000);
			
		} 
		else { alert("sendEmail.exe program is not found! \n\n Please visit Options dialog to get the link for free downloads.");}
	}
	else if (tmpflag == 0) {
		// Preview (flag = false)
			window.open("file://"+tempfilepath+"spbe_tmp.html");		
	}
}

function stringRecursiveReplace(string, oldstr, newstr){
	while (string.indexOf(oldstr) != -1){
		string = string.replace(oldstr, newstr);
	}
	return string;
}

function spbe_alertShow(){

	var alertsService = Components.classes["@mozilla.org/alerts-service;1"]
                              .getService(Components.interfaces.nsIAlertsService);

	alertsService.showAlertNotification("", "Success", "Email was sent successfully.", 
                                    false, "", null);
}

function validateSentEmail(subject, flag){

	var spbeOptions = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("sendpagebyemail.");		  
	var logfilepath = spbeOptions.getCharPref("opt_pathToTempFile")+"spbe_log.txt";
	
	var logfile = Components.classes["@mozilla.org/file/local;1"] .createInstance(Components.interfaces.nsILocalFile); 
	logfile.initWithPath(logfilepath);

	if (logfile.exists()){
		var istream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		istream.init(logfile, 0x01, 0444, 0);
		istream.QueryInterface(Components.interfaces.nsILineInputStream);
		
		var logtxt = {};
		istream.readLine(logtxt);
		istream.close();

		if (logtxt.value.indexOf("successfully") == -1) {
			var errindex = logtxt.value.indexOf("ERROR")
				if (errindex != -1)
					alert("Failed to send the email with the subject: "+ subject+". \n\n Error: "+logtxt.value.substring(errindex, logtxt.value.length+1));
				else alert("Failed to send the email with the subject: "+ subject+". \n\n  Error: Unknown.");
		} else spbe_alertShow(); // email sent successfully and show alerts. 
   		logfile.remove(false);
	}
    else {
		if (flag == 0) alert("Failed to send the email with the subject: "+ subject+". \n Or you have attachments which are too large to be sent in a short time. Please check manually! \n\n  Error: Unknown.");
		else setTimeout("validateSentEmail('" + subject + "'," + 0 +");", 10000);
	}
}

